#{extends 'border.html'/}
<div class="container">
<form class="api form-horizontal" name="frmInput">

	<div class="row">
		<div class="col-md-12">
			<h3>&{'layanan.label'} &{'rup.label'}</h3>
		</div>
	</div>
	
	<div class="row">
		<div class="col-md-12">
			<div class="panel panel-default">
				<div class="panel-body">
					<div class="form-group">
						<label class="control-label col-md-2">&{'tanggal_perbaharui.label'}</label>
						<div class="col-md-2">
							<input type="text" id="tanggal-update" class="form-control datepicker" value="${tanggalUpdate}">
						</div>
			   		</div>
			   		<div class="form-group">
			   			<div class="col-md-1 col-md-offset-2">
				      		<button type="button" class="btn btn-primary btn-block start">&{'mulai.label'}</button>
				      	</div>
			   		</div>
				</div>
			</div>
		</div>
   </div>
   
    <div class="row">
        <div class="col-md-12">
        	#{alert /}
            <div class="console">
                <div class="title">&{'layanan.label'} &{'status.label'}</div>
                <div class="content">
                    <div class="result" id="result"></div>
                </div>
            </div>
        </div>
    </div>
    
</form>
</div>

#{set 'moreScripts'}
<script src="@{'/public/javascripts/jquery/eventsource/jquery.eventsource.js'}" type="text/javascript"></script>
<script type="text/javascript">
    var winIdList = $(".api");
    var apiResult = winIdList.find(".console .result");
    var frmInput = winIdList.find("form[name=frmInput]");
    var btnStart = winIdList.find(".start");

    var es;

    if(typeof (EventSource) !== "undefined"){
        apiResult.append("Silahkan tekan tombol [Start] untuk memulai.");
        var isEsSupported = true;
    } else {
        apiResult.append("Perhatian!<br />Browser anda tidak mendukung fitur EventSource (HTML 5). Service status akan ditampilkan apabila proses telah selesai 100%.<br /><br />Silahkan tekan tombol [Start] untuk memulai.");
        var isEsSupported = false;
    }

    function startMessage () {

        if (!isEsSupported) {
            $().myAlertDialog({
                title: "<?php echo $this->lang->line('error'); ?>"
                , message: "Internet browser anda tidak mendukung SSE."
            });
            return false;
        }

        btnStart.attr("disabled", true);

        var tanggalUpdate = $("#tanggal-update").val();
        apiResult.empty();
        var url = '@{api.KatalogApiCtr.formRupSubmit()}'+ '?tanggal_update=' + tanggalUpdate;
        es = new EventSource(url);
        es.onmessage = function(e) {
            var isJson = true;
            try {
                var data = $.parseJSON(e.data);
            } catch (err) {
                isJson = false;
            }

            if (!isJson) {
                $().apiStop();
                alert("is not json");
                return;
            }

            if (data.newLine) {
                apiResult.append("<div></div>");
            }
            var div = apiResult.find("div:last");

            if (div.length == 0) {
                var div = apiResult;
            }

            div.append(data.message);
            if (data.suffixWithProgress) {
                div.append(' <span class="smallLoadingBar"></span> ');
            } else {
                div.find(".smallLoadingBar").remove();
            }

            if (data.isEnd) {
                $().apiStop();
            }
        };

    }
    $.fn.apiStop = function() {
        es.close();
        btnStart.attr("disabled", false);
    }

    $("body").on("click", ".start", function (e) {
        e.preventDefault();
        $.showLoading();
        setTimeout(startMessage(),1000)
        setTimeout($.hideLoading(), 2000)

    })
</script>
#{/set}
